#include "SampleApplication.h"

class CLightingApplication : public CSampleApplication  
{
public:
	CLightingApplication();
	virtual ~CLightingApplication();

	//These functions are called by the framework.
	virtual BOOL Initialize();
	virtual BOOL Terminate();
	virtual void Render();
	virtual BOOL HandleMessage(MSG *pMessage);

	//SH specific functions
	HRESULT LoadSHDataFromFile(char *pFileName);
	HRESULT SetSHShaderConstants(D3DXVECTOR3 *pObjectSpaceLightVector);

	//SH specific variables
    ID3DXPRTBuffer*     m_pPRTBuffer;
    ID3DXPRTCompBuffer* m_pPRTCompBuffer;

	char*          m_pSHDataFileName;
	float*         m_ClusterBases;
	float*         m_ClusteredPCA;
};
